TITLE<' LPrint '>
SUBTTL<' Line Print Utility for LDOS '>
ORG5200H
;LPrint/Cmd....Lineprint from keyboard input Pgm.
;Functions:
;Unquoted strings are printed up 
;to and including the ending <Cr>.
;Quoted strings have the contents
;of the quotes printed, and can be used with other
;functions on the same line.
;"*" or "#" followed by two 
;charactors will print the corresponding hex
;charactor.  More than one charactor can be
;printed by entering pairs of charactors
;seperated by a comma.  In a multiple function
;line, end the hex function by following the
;last pair of charactors with ";".
;"@Time" will print the 8 char
;translation of the current system time.
;"@Date" will print the 8 char
;system date.  Both "@Time" and "@Date" can be
;combined with other functions on the same line
;when seperated by "," or ";".
;"$xxx'X'" prints a string of
;charactors.  The number replacing xxx above is
;the number of char. desired, and the charactor
;replacing X is the charactor that is printed.
;
@EXITEQU402DH
@PRTMSGEQU446AH;Msg to Printer call.
@PRTCHREQU003BH;1 char to printer call
@TIMEEQU446DH;Get time call
@DATEEQU4470H;Get Date call
@CVINPEQU1E5AH;ROM input chr to # call
LOOPINCHL;poiant to next char
LPRINTLDA,(HL);get char
CP20H;Space?
JRZ,LOOP;skip to next char if so.
CP'#';Hex output request?
JRZ,HEXCHR;service if so.
CP'*';Alternate Char for Hex request
JRZ,HEXCHR
CP'@';Special function?
JPZ,@CHR
CP'$';String of chars?
JPZ,STR$
CP'"';Quoted string?
JPZ,QSTR
CP','
JRZ,LOOP;skip seperator
CP';';skip <cr> ?
JRZ,LOOP
CP0DH;end of line?
JRZ,EOL
CALL@PRTMSG;print message!
EXITJP@EXIT;Return to DOS
EOLDECHL;Get prev. char
LDA,(HL)
CP';';Suppress <CR> ?
JRZ,EOL2
LDA,0DH;carriage return
CALL@PRTCHR
EOL2JREXIT
HEXCHRINCHL;point to next char
LDA,(HL);get it
CP0DH;end of line?
JRZ,EXIT;done if so.
LDB,0;B will hold the hex byte
CALLCVT;Convert 1st nibble
LDB,A;save it.
SLAB;Shift first
SLAB;nibble
SLAB;into it's
SLAB;proper position.
INCHL;point to 2nd nibble.
LDA,(HL);get it
CALLCVT;convert 2nd nibble
ORB;combine nibbles
CALL@PRTCHR;Output to the printer.
INCHL;point at next char
LDA,(HL);get it
CP',';Seperator...ie more?
JRZ,HEXCHR;loop for it if so.
CP';';More to print?
JRZ,LOOP
JREXIT;if not, done!
CVTSUB30H;offset to 0-9
JPM,CVTE;detect bad chars
CP0AH;check if nibble is 0-9
RETM;done if so.
RES5,A;convert lower case to upper.
SUB7;remove offset to A-F
CP0AH;check for bad chars
JPM,CVTE;and deal with them.
CP10H;other bad chars?
RETM;we'er ok if not >0FH.
CVTELDA,0;return value of 0H
RET
QSTRINCHL
LDA,(HL);Get next char
CP'"';end of string?
JPZ,LOOP;then look for more req.
CP0DH;end of line?
JPZ,EXIT;then done.
CALL@PRTCHR;send char to printer
JRQSTR;loop for next char
@CHRINCHL
LDA,(HL);Get next char.
RES5,A;Convert case to upper
CP'T';@TIME call?
JRZ,TIME
CP'D';@DATE Call?
JRZ,DATE
JPEXIT;skip if not valid
TIMEPUSHHL
LDHL,BUFR
CALL@TIME;load time
LDHL,BUFR
CALL@PRTMSG;print it
@NEXTPOPHL
INCHL
INCHL
INCHL
INCHL;advance past "@time"
LDA,(HL)
CP0DH
JRZ,@CX
CP','
JPZ,LOOP
CP';'
JPZ,LOOP
@CXCALL@PRTCHR
JPEXIT
DATEPUSHHL
LDHL,BUFR
CALL@DATE
LDHL,BUFR
CALL@PRTMSG
JR@NEXT
STR$INCHL;point to number string
STR$OKCALL@CVINP;convert to hex number
LDB,E;Get count into B
INCHL;point to char to repeat
STR$1LDA,(HL);get char
CALL@PRTCHR;print 1 char
DJNZSTR$1;loop for # requested.
INCHL;skip to end of cmd.
JPLOOP;process rest of line
BUFRDM'xx:xx:xx'
DB03H
ENDLPRINT
